#property indicator_separate_window
#property indicator_buffers 4
#property indicator_maximum 9
#property indicator_minimum 0
#property indicator_color1 Lime
#property indicator_width1 5
#property indicator_color2 Red
#property indicator_width2 5
#property indicator_color3 Blue
#property indicator_width3 5
#property indicator_color4 Yellow
#property indicator_width4 5

extern int		SydneyOpen		= 0;
extern int		SydneyClose		= 8;
extern int		TokyoOpen		= 2;
extern int		TokyoClose		= 10;
extern int		LondonOpen		= 10;
extern int		LondonClose		= 18;
extern int		NewYorkOpen		= 15;
extern int		NewYorkClose	= 0;

// Buffers

double dSydneyBuffer[];
double dTokyoBuffer[];
double dLondonBuffer[];
double dNewYorkBuffer[];

int init() {

	IndicatorShortName("");
	
	SetIndexBuffer(0,dSydneyBuffer);
	SetIndexLabel(0,"Sydney");
	SetIndexBuffer(1,dTokyoBuffer);
	SetIndexLabel(1,"Tokyo");
	SetIndexBuffer(2,dLondonBuffer);
	SetIndexLabel(2,"London");
	SetIndexBuffer(3,dNewYorkBuffer);
	SetIndexLabel(3,"New York");
	
	return(0);
}

int start() {

// Determine number of bars to iterate over
	int iBarsToCalc = Bars - IndicatorCounted();
	if (iBarsToCalc < Bars) iBarsToCalc++;
	
// Iterate over bars
	for (int i=iBarsToCalc-1;i>=0;i--) {
					
// Set Sydney Line
		if (isMarketOpen(SydneyOpen, SydneyClose, Time[i]))
			dSydneyBuffer[i] = 8;
		else
			dSydneyBuffer[i] = EMPTY_VALUE;
				
// Set Tokyo Line
		if (isMarketOpen(TokyoOpen, TokyoClose, Time[i]))
			dTokyoBuffer[i] = 6;
		else
			dTokyoBuffer[i] = EMPTY_VALUE;
// Set London Line
		if (isMarketOpen(LondonOpen, LondonClose, Time[i]))
			dLondonBuffer[i] = 4;
		else
			dLondonBuffer[i] = EMPTY_VALUE;
		
// Set NewYork Line
		if (isMarketOpen(NewYorkOpen, NewYorkClose, Time[i]))
			dNewYorkBuffer[i] = 2;
		else
			dNewYorkBuffer[i] = EMPTY_VALUE;
	}

}

bool isMarketOpen(int iOpenHour, int iCloseHour, datetime timestamp) {

	int iBarHour = TimeHour(timestamp);
	
	if (iOpenHour < iCloseHour && (iBarHour >= iOpenHour && iBarHour < iCloseHour))
		return(true);
	if (iOpenHour > iCloseHour && (iBarHour >= iOpenHour || iBarHour < iCloseHour))
		return(true);
		
	return(false);
}

